vsg: vsg::txt Class Reference

vsg 1.1.9 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | List of all members
vsg::txt Class Reference

ReaderWriter for reading and writing text files of different types such as .txt, ,md, .json, .xml. More...

`#include <txt.h>`

Inheritance diagram for vsg::txt:
[legend]
Collaboration diagram for vsg::txt:
[legend]

## Public Member Functions
ref_ptr< Object > | read (const Path &filename, ref_ptr< const Options > options={}) const override
| read object from file, return object on success, return null ref_ptr<> if format not supported, or return ReadError on failure.
ref_ptr< Object > | read (std::istream &fin, ref_ptr< const Options > options={}) const override
| read object from input stream, return object on success, return null ref_ptr<> if format not supported, or return ReadError on failure.
ref_ptr< Object > | read (const uint8_t *ptr, size_t size, ref_ptr< const Options >={}) const override
| read object from memory block, return object on success, return null ref_ptr<> if format not supported, or return ReadError on failure.
bool | getFeatures (Features &features) const override
| get the Features supported by this ReaderWriter
Public Member Functions inherited from vsg::Inherit< ReaderWriter, txt >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::ReaderWriter
template<class T>
vsg::ref_ptr< T > | read_cast (const vsg::Path &filename, vsg::ref_ptr< const vsg::Options > options={}) const
| convenience method for casting a read object to a specified type.
template<class T>
vsg::ref_ptr< T > | read_cast (std::istream &fin, vsg::ref_ptr< const vsg::Options > options={}) const
| convenience method for casting a read object to a specified type.
template<class T>
vsg::ref_ptr< T > | read_cast (const uint8_t *ptr, size_t size, vsg::ref_ptr< const vsg::Options > options={}) const
| convenience method for casting a read object to a specified type.
virtual bool | write (const vsg::Object *, const vsg::Path &, vsg::ref_ptr< const vsg::Options >={}) const
| write object to file, return true on success, return false on failure.
virtual bool | write (const vsg::Object *, std::ostream &, vsg::ref_ptr< const vsg::Options >={}) const
| write object to output stream, return true on success, return false on failure.
virtual bool | readOptions (Options &, CommandLine &) const
| read the command line arguments for any options appropriate for this ReaderWriter
virtual void | read (Input &input)
virtual void | write (Output &output) const
Public Member Functions inherited from vsg::Inherit< Object, ReaderWriter >
| Inherit (Args &&... args)
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | traverse (ConstVisitor &) const
virtual void | traverse (RecordTraversal &) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Static Public Member Functions
static bool | extensionSupported (const vsg::Path &path)
| built-in supported extensions
Static Public Member Functions inherited from vsg::Inherit< ReaderWriter, txt >
static ref_ptr< txt > | create (Args &&... args)
static ref_ptr< txt > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Inherit< Object, ReaderWriter >
static ref_ptr< ReaderWriter > | create (Args &&... args)
static ref_ptr< ReaderWriter > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Public Attributes
std::set< vsg::Path > | supportedExtensions
| supported extensions, users may add/remove entries to customize which types of files can be read as a text string.

## Protected Member Functions
ref_ptr< Object > | _read (std::istream &fin, ref_ptr< const Options > options={}) const
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Additional Inherited Members
Public Types inherited from vsg::ReaderWriter
enum | FeatureMask { READ_FILENAME = (1 << 0) , READ_ISTREAM = (1 << 1) , READ_MEMORY = (1 << 2) , WRITE_FILENAME = (1 << 3) , WRITE_OSTREAM = (1 << 4) }

## Detailed Description

ReaderWriter for reading and writing text files of different types such as .txt, ,md, .json, .xml.

## Member Function Documentation

## ◆ getFeatures()

bool vsg::txt::getFeatures | ( | Features & |  | ) | const
| overridevirtual

get the Features supported by this ReaderWriter

Reimplemented from vsg::ReaderWriter.

## ◆ read() [1/3]

ref_ptr< Object > vsg::txt::read | ( | const Path & | ,
|  | ref_ptr< const Options > | = {} ) const
| overridevirtual

read object from file, return object on success, return null ref_ptr<> if format not supported, or return ReadError on failure.

Reimplemented from vsg::ReaderWriter.

## ◆ read() [2/3]

ref_ptr< Object > vsg::txt::read | ( | const uint8_t * | ,
|  | size_t | ,
|  | ref_ptr< const Options > | = {} ) const
| overridevirtual

read object from memory block, return object on success, return null ref_ptr<> if format not supported, or return ReadError on failure.

Reimplemented from vsg::ReaderWriter.

## ◆ read() [3/3]

ref_ptr< Object > vsg::txt::read | ( | std::istream & | ,
|  | ref_ptr< const Options > | = {} ) const
| overridevirtual

read object from input stream, return object on success, return null ref_ptr<> if format not supported, or return ReadError on failure.

Reimplemented from vsg::ReaderWriter.

The documentation for this class was generated from the following file:

- include/vsg/io/txt.h